var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('angular2/core');
var Prism = require('prismjs/prism');
require('prismjs/components/prism-bash');
require('prismjs/components/prism-javascript');
require('prismjs/plugins/line-numbers/prism-line-numbers');
require('prismjs/plugins/normalize-whitespace/prism-normalize-whitespace');
var CodeblockComponent = (function () {
    function CodeblockComponent(_elementRef) {
        this._elementRef = _elementRef;
        this._language = 'bash';
    }
    Object.defineProperty(CodeblockComponent.prototype, "language", {
        get: function () {
            return this._language;
        },
        set: function (lang) {
            this._language = lang || 'bash';
            this.highlight();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CodeblockComponent.prototype, "languageSelector", {
        get: function () {
            return 'language-' + this._language;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CodeblockComponent.prototype, "el", {
        get: function () {
            return this._elementRef.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    CodeblockComponent.prototype.highlight = function () {
        this._setLanguageClasses();
        var elements = this.el.querySelectorAll("code[class*=\"language-\"],\n      [class*=\"language-\"] code,\n      code[class*=\"lang-\"],\n      [class*=\"lang-\"] code");
        for (var i = 0, element; element = elements[i++];) {
            Prism.highlightElement(element, false, null);
        }
    };
    CodeblockComponent.prototype._setLanguageClasses = function () {
        this.el.querySelector('pre').className = "line-numbers " + this.languageSelector;
        this.el.querySelector('code').className = this.languageSelector + " " + this._language;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String), 
        __metadata('design:paramtypes', [String])
    ], CodeblockComponent.prototype, "language", null);
    CodeblockComponent = __decorate([
        core_1.Component({
            selector: 'codeblock',
            template: "\n    <div class=\"codeblock\">\n      <h2>{{language}}</h2>\n      <pre>\n        <code>\n          <ng-content></ng-content>\n        </code>\n      </pre>\n    </div>\n  ",
            styleUrls: [
                'node_modules/prismjs/themes/prism-okaidia.css',
                'node_modules/prismjs/plugins/line-numbers/prism-line-numbers.css'
            ],
            styles: ["\n    .codeblock pre.line-numbers {\n      padding-left: 3.4em;\n    }\n\n    .codeblock pre.line-numbers .line-numbers-rows {\n      left: -3.4em;\n      border: none;\n    }\n  "],
            encapsulation: core_1.ViewEncapsulation.None
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef])
    ], CodeblockComponent);
    return CodeblockComponent;
})();
exports.CodeblockComponent = CodeblockComponent;
//# sourceMappingURL=codeblock.component.js.map